/*
 * The contents of this file are subject to the terms 
 * of the Common Development and Distribution License 
 * (the License).  You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the license at 
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing 
 * permissions and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL 
 * Header Notice in each file and include the License file 
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.  
 * If applicable, add the following below the CDDL Header, 
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information: 
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Copyright 2006 Sun Microsystems, Inc. All rights reserved.
 */

package com.sun.enterprise.cli.commands.monitor;

import com.sun.enterprise.cli.framework.*;
import com.sun.appserv.management.monitor.*;
import com.sun.appserv.management.monitor.statistics.*;
import javax.management.j2ee.statistics.*;
import com.sun.appserv.management.j2ee.statistics.*;
import com.sun.enterprise.util.i18n.StringManager;
import com.sun.appserv.management.util.misc.MapUtil;
import java.util.Map;
import java.util.Timer;
import java.io.File;

public class ConnectionManagerMonitorTask extends MonitorTask
{
    private final String displayFormat = "%1$-5s %2$-5s %3$-5s %4$-20s %5$-5s %6$-5s %7$-5s";

    public ConnectionManagerMonitorTask(final ServerRootMonitor srm, final String filter,
                                        final Timer timer, final boolean verbose, final File fileName)
        throws MonitorTaskException
    {
        super(srm, filter, timer, verbose, fileName);
        
        final Map<String,ConnectionManagerMonitor> connectionManagerMap  = srm.getConnectionManagerMonitorMap();
        
        if (connectionManagerMap == null)
            throw new MonitorTaskException("Unable to monitor connection manager");
        
        final String[] keys = MapUtil.getKeyStrings(connectionManagerMap);
        if (this.filter == null)
        {
            checkForNumberOfElements(keys);
            this.filter = keys[0];
        }
        else {
            if (!connectionManagerMap.containsKey(this.filter)) {
                throw new MonitorTaskException(this.filter + " does not exist");
            }
        }
        final String title = String.format("%1$5s", "Connection Manager Monitoring: " + this.filter);
        System.out.println(title);
        displayHeader();        
    }
    

    public void run()
    {
        if (srm == null)
        {
            super.cancelMonitorTask();
            return;
        }
        
        final Map<String,ConnectionManagerMonitor> connectionManagerMap  = srm.getConnectionManagerMonitorMap();
        if (connectionManagerMap == null || connectionManagerMap.size()<0)
        {
            super.cancelMonitorTask();
            return;
        }
        
            
        final ConnectionManagerMonitor connectionManagerMonitor = connectionManagerMap.get(filter);
        if (connectionManagerMonitor == null)
        {
            cancelMonitorTask();
            return;
        }
        
            
        final ConnectionManagerStats connectionManagerStats = connectionManagerMonitor.getConnectionManagerStats();

        if (verbose && counter == NUM_ROWS)
        {
            displayHeader();
            counter = 0;  //reset to 0
        }
        displayData(connectionManagerStats);
        if (verbose) counter++;
    }

    
    private void displayHeader()
    {
        final String header = String.format("%1$35s",
                                            "TotalConnections");
        final String subheader = String.format(displayFormat,
                                            "ci","ciu","low","hi","cur","min","max");
        System.out.println(header);
        System.out.println(subheader);        
        if (fileName != null)
        {
            writeToFile("ConnectionIdle,ConnectionInUse,TotalConnections:low,"+
                        "TotalConnections:hi,TotalConnection:current,TotalConnection:min"+
                        "TotalConnections:max");
        }
    }

    
    private void displayData(final ConnectionManagerStats cms)
    {
        final String data = String.format(displayFormat,
                                          cms.getConnectionsIdle().getCount(),
                                          cms.getConnectionsInUse().getCount(),
                                          cms.getTotalConnections().getLowerBound(),
                                          cms.getTotalConnections().getUpperBound(),
                                          cms.getTotalConnections().getLowWaterMark(),
                                          cms.getTotalConnections().getHighWaterMark(),                                          
                                          cms.getTotalConnections().getCurrent());
        System.out.println(data);
        if (fileName != null)
        {
            final String fileData = String.format("%1$s,%2$s,%3$s,%4$s,%5$s,%6$s,%7$s",
                                          cms.getConnectionsIdle().getCount(),
                                          cms.getConnectionsInUse().getCount(),
                                          cms.getTotalConnections().getLowerBound(),
                                          cms.getTotalConnections().getUpperBound(),
                                          cms.getTotalConnections().getLowWaterMark(),
                                          cms.getTotalConnections().getHighWaterMark(),                                          
                                          cms.getTotalConnections().getCurrent());
            writeToFile(fileData);
        }
    }

    
    public void displayDetails()
    {
        
        System.out.println("*******************************************************");
        System.out.println("* ci  = Total number of idle connections to the ORB   *");
        System.out.println("* ciu = Total number of in-use connections to the ORB *");        
        System.out.println("* low = Lower bound of connections to the ORB         *");
        System.out.println("* hi  = Upper bound of connections to the ORB         *");
        System.out.println("* cur = Current number of connections to the ORB      *");
        System.out.println("* min = High Water Mark                               *");
        System.out.println("* max = Low Water Mark                                *");
        System.out.println("*******************************************************");        
    }


}
    
    

